Index: src/Parser/parser.h
===================================================================
--- src/Parser/parser.h	(revision ac71a86572d01aed1e339480e09e6506e81f3a09)
+++ src/Parser/parser.h	(revision 0555f4bcb3f9d01c36c8df66c8417c065804176b)
@@ -1,18 +1,18 @@
-/* A Bison parser, made by GNU Bison 3.0.2.  */
+/* A Bison parser, made by GNU Bison 2.5.  */
 
 /* Bison interface for Yacc-like parsers in C
-
-   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
-
+   
+      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
+   
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
-
+   
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
-
+   
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
@@ -27,130 +27,122 @@
    Bison output files to be licensed under the GNU General Public
    License without this special exception.
-
+   
    This special exception was added by the Free Software Foundation in
    version 2.2 of Bison.  */
 
-#ifndef YY_YY_PARSER_PARSER_H_INCLUDED
-# define YY_YY_PARSER_PARSER_H_INCLUDED
-/* Debug traces.  */
-#ifndef YYDEBUG
-# define YYDEBUG 1
-#endif
-#if YYDEBUG
-extern int yydebug;
-#endif
-
-/* Token type.  */
+
+/* Tokens.  */
 #ifndef YYTOKENTYPE
 # define YYTOKENTYPE
-  enum yytokentype
-  {
-    TYPEDEF = 258,
-    AUTO = 259,
-    EXTERN = 260,
-    REGISTER = 261,
-    STATIC = 262,
-    INLINE = 263,
-    FORTRAN = 264,
-    CONST = 265,
-    VOLATILE = 266,
-    RESTRICT = 267,
-    FORALL = 268,
-    LVALUE = 269,
-    VOID = 270,
-    CHAR = 271,
-    SHORT = 272,
-    INT = 273,
-    LONG = 274,
-    FLOAT = 275,
-    DOUBLE = 276,
-    SIGNED = 277,
-    UNSIGNED = 278,
-    VALIST = 279,
-    BOOL = 280,
-    COMPLEX = 281,
-    IMAGINARY = 282,
-    TYPEOF = 283,
-    LABEL = 284,
-    ENUM = 285,
-    STRUCT = 286,
-    UNION = 287,
-    OTYPE = 288,
-    FTYPE = 289,
-    DTYPE = 290,
-    TRAIT = 291,
-    SIZEOF = 292,
-    OFFSETOF = 293,
-    ATTRIBUTE = 294,
-    EXTENSION = 295,
-    IF = 296,
-    ELSE = 297,
-    SWITCH = 298,
-    CASE = 299,
-    DEFAULT = 300,
-    DO = 301,
-    WHILE = 302,
-    FOR = 303,
-    BREAK = 304,
-    CONTINUE = 305,
-    GOTO = 306,
-    RETURN = 307,
-    CHOOSE = 308,
-    DISABLE = 309,
-    ENABLE = 310,
-    FALLTHRU = 311,
-    TRY = 312,
-    CATCH = 313,
-    CATCHRESUME = 314,
-    FINALLY = 315,
-    THROW = 316,
-    THROWRESUME = 317,
-    AT = 318,
-    ASM = 319,
-    ALIGNAS = 320,
-    ALIGNOF = 321,
-    ATOMIC = 322,
-    GENERIC = 323,
-    NORETURN = 324,
-    STATICASSERT = 325,
-    THREADLOCAL = 326,
-    IDENTIFIER = 327,
-    QUOTED_IDENTIFIER = 328,
-    TYPEDEFname = 329,
-    TYPEGENname = 330,
-    ATTR_IDENTIFIER = 331,
-    ATTR_TYPEDEFname = 332,
-    ATTR_TYPEGENname = 333,
-    INTEGERconstant = 334,
-    FLOATINGconstant = 335,
-    CHARACTERconstant = 336,
-    STRINGliteral = 337,
-    ZERO = 338,
-    ONE = 339,
-    ARROW = 340,
-    ICR = 341,
-    DECR = 342,
-    LS = 343,
-    RS = 344,
-    LE = 345,
-    GE = 346,
-    EQ = 347,
-    NE = 348,
-    ANDAND = 349,
-    OROR = 350,
-    ELLIPSIS = 351,
-    MULTassign = 352,
-    DIVassign = 353,
-    MODassign = 354,
-    PLUSassign = 355,
-    MINUSassign = 356,
-    LSassign = 357,
-    RSassign = 358,
-    ANDassign = 359,
-    ERassign = 360,
-    ORassign = 361,
-    ATassign = 362,
-    THEN = 363
-  };
+   /* Put the tokens into the symbol table, so that GDB and other debuggers
+      know about them.  */
+   enum yytokentype {
+     TYPEDEF = 258,
+     AUTO = 259,
+     EXTERN = 260,
+     REGISTER = 261,
+     STATIC = 262,
+     INLINE = 263,
+     FORTRAN = 264,
+     CONST = 265,
+     VOLATILE = 266,
+     RESTRICT = 267,
+     FORALL = 268,
+     LVALUE = 269,
+     VOID = 270,
+     CHAR = 271,
+     SHORT = 272,
+     INT = 273,
+     LONG = 274,
+     FLOAT = 275,
+     DOUBLE = 276,
+     SIGNED = 277,
+     UNSIGNED = 278,
+     VALIST = 279,
+     BOOL = 280,
+     COMPLEX = 281,
+     IMAGINARY = 282,
+     TYPEOF = 283,
+     LABEL = 284,
+     ENUM = 285,
+     STRUCT = 286,
+     UNION = 287,
+     OTYPE = 288,
+     FTYPE = 289,
+     DTYPE = 290,
+     TRAIT = 291,
+     SIZEOF = 292,
+     OFFSETOF = 293,
+     ATTRIBUTE = 294,
+     EXTENSION = 295,
+     IF = 296,
+     ELSE = 297,
+     SWITCH = 298,
+     CASE = 299,
+     DEFAULT = 300,
+     DO = 301,
+     WHILE = 302,
+     FOR = 303,
+     BREAK = 304,
+     CONTINUE = 305,
+     GOTO = 306,
+     RETURN = 307,
+     CHOOSE = 308,
+     DISABLE = 309,
+     ENABLE = 310,
+     FALLTHRU = 311,
+     TRY = 312,
+     CATCH = 313,
+     CATCHRESUME = 314,
+     FINALLY = 315,
+     THROW = 316,
+     THROWRESUME = 317,
+     AT = 318,
+     ASM = 319,
+     ALIGNAS = 320,
+     ALIGNOF = 321,
+     ATOMIC = 322,
+     GENERIC = 323,
+     NORETURN = 324,
+     STATICASSERT = 325,
+     THREADLOCAL = 326,
+     IDENTIFIER = 327,
+     QUOTED_IDENTIFIER = 328,
+     TYPEDEFname = 329,
+     TYPEGENname = 330,
+     ATTR_IDENTIFIER = 331,
+     ATTR_TYPEDEFname = 332,
+     ATTR_TYPEGENname = 333,
+     INTEGERconstant = 334,
+     FLOATINGconstant = 335,
+     CHARACTERconstant = 336,
+     STRINGliteral = 337,
+     ZERO = 338,
+     ONE = 339,
+     ARROW = 340,
+     ICR = 341,
+     DECR = 342,
+     LS = 343,
+     RS = 344,
+     LE = 345,
+     GE = 346,
+     EQ = 347,
+     NE = 348,
+     ANDAND = 349,
+     OROR = 350,
+     ELLIPSIS = 351,
+     MULTassign = 352,
+     DIVassign = 353,
+     MODassign = 354,
+     PLUSassign = 355,
+     MINUSassign = 356,
+     LSassign = 357,
+     RSassign = 358,
+     ANDassign = 359,
+     ERassign = 360,
+     ORassign = 361,
+     ATassign = 362,
+     THEN = 363
+   };
 #endif
 /* Tokens.  */
@@ -262,10 +254,13 @@
 #define THEN 363
 
-/* Value type.  */
+
+
+
 #if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
-typedef union YYSTYPE YYSTYPE;
-union YYSTYPE
+typedef union YYSTYPE
 {
-#line 115 "parser.yy" /* yacc.c:1909  */
+
+/* Line 2068 of yacc.c  */
+#line 156 "parser.yy"
 
 	Token tok;
@@ -281,16 +276,18 @@
 	InitializerNode *in;
 	OperKinds op;
+	std::string *str;
 	bool flag;
 
-#line 286 "Parser/parser.h" /* yacc.c:1909  */
-};
+
+
+/* Line 2068 of yacc.c  */
+#line 285 "Parser/parser.h"
+} YYSTYPE;
 # define YYSTYPE_IS_TRIVIAL 1
+# define yystype YYSTYPE /* obsolescent; will be withdrawn */
 # define YYSTYPE_IS_DECLARED 1
 #endif
 
-
 extern YYSTYPE yylval;
 
-int yyparse (void);
-
-#endif /* !YY_YY_PARSER_PARSER_H_INCLUDED  */
+