Index: src/SynTree/Expression.cc
===================================================================
--- src/SynTree/Expression.cc	(revision 9243a50199e3b682c9f127c7ef2e5026dfed5c2f)
+++ src/SynTree/Expression.cc	(revision 630a82a5214317b27ab087ea8d7665b217527f07)
@@ -9,6 +9,6 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Rob Schluntz
-// Last Modified On : Wed May 04 12:14:09 2016
+// Last Modified By : Peter A. Buhr
+// Last Modified On : Fri Apr  8 17:16:23 2016
 // Update Count     : 40
 //
@@ -72,5 +72,5 @@
 
 void ConstantExpr::print( std::ostream &os, int indent ) const {
-	os << "constant expression " ;
+	os << std::string( indent, ' ' ) << "constant expression " ;
 	constant.print( os );
 	Expression::print( os, indent );
@@ -93,5 +93,5 @@
 
 void VariableExpr::print( std::ostream &os, int indent ) const {
-	os << "Variable Expression: ";
+	os << std::string( indent, ' ' ) << "Variable Expression: ";
 
 	Declaration *decl = get_var();
@@ -122,5 +122,5 @@
 
 void SizeofExpr::print( std::ostream &os, int indent) const {
-	os << "Sizeof Expression on: ";
+	os << std::string( indent, ' ' ) << "Sizeof Expression on: ";
 
 	if (isType)
@@ -223,25 +223,4 @@
 }
 
-OffsetPackExpr::OffsetPackExpr( StructInstType *type_, Expression *aname_ ) : Expression( aname_ ), type( type_ ) {
-	add_result( new ArrayType( Type::Qualifiers(), new BasicType( Type::Qualifiers(), BasicType::LongUnsignedInt ), 0, false, false ) );
-}
-
-OffsetPackExpr::OffsetPackExpr( const OffsetPackExpr &other ) : Expression( other ), type( maybeClone( other.type ) ) {}
-
-OffsetPackExpr::~OffsetPackExpr() { delete type; }
-
-void OffsetPackExpr::print( std::ostream &os, int indent ) const {
-	os << std::string( indent, ' ' ) << "Offset pack expression on ";
-
-	if ( type ) {
-		type->print(os, indent + 2);
-	} else {
-		os << "<NULL>";
-	}
-
-	os << std::endl;
-	Expression::print( os, indent );
-}
-
 AttrExpr::AttrExpr( Expression *attr, Expression *expr_, Expression *_aname ) :
 		Expression( _aname ), attr( attr ), expr(expr_), type(0), isType(false) {
@@ -295,5 +274,5 @@
 
 void CastExpr::print( std::ostream &os, int indent ) const {
-	os << "Cast of:" << std::endl << std::string( indent+2, ' ' );
+	os << std::string( indent, ' ' ) << "Cast of:" << std::endl;
 	arg->print(os, indent+2);
 	os << std::endl << std::string( indent, ' ' ) << "to:" << std::endl;
@@ -318,12 +297,9 @@
 
 void UntypedMemberExpr::print( std::ostream &os, int indent ) const {
-	os << "Untyped Member Expression, with field: " << get_member();
+	os << std::string( indent, ' ' ) << "Member Expression, with field: " << get_member();
 
 	Expression *agg = get_aggregate();
-	os << ", from aggregate: ";
-	if (agg != 0) {
-		agg->print(os, indent + 2);
-	}
-	os << std::string( indent+2, ' ' );
+	os << std::string( indent, ' ' ) << "from aggregate: ";
+	if (agg != 0) agg->print(os, indent + 2);
 	Expression::print( os, indent );
 }
@@ -348,5 +324,5 @@
 
 void MemberExpr::print( std::ostream &os, int indent ) const {
-	os << "Member Expression, with field: " << std::endl;
+	os << std::string( indent, ' ' ) << "Member Expression, with field: " << std::endl;
 
 	assert( member );
@@ -357,8 +333,5 @@
 	Expression *agg = get_aggregate();
 	os << std::string( indent, ' ' ) << "from aggregate: " << std::endl;
-	if (agg != 0) {
-		agg->print(os, indent + 2);
-	}
-	os << std::string( indent+2, ' ' );
+	if (agg != 0) agg->print(os, indent + 2);
 	Expression::print( os, indent );
 }
@@ -378,9 +351,8 @@
 
 void UntypedExpr::print( std::ostream &os, int indent ) const {
-	os << "Applying untyped: " << std::endl;
-	os << std::string( indent+4, ' ' );
+	os << std::string( indent, ' ' ) << "Applying untyped: " << std::endl;
 	function->print(os, indent + 4);
 	os << std::string( indent, ' ' ) << "...to: " << std::endl;
-	printAll(args, os, indent + 4);
+	printArgs(os, indent + 4);
 	Expression::print( os, indent );
 }
@@ -388,8 +360,6 @@
 void UntypedExpr::printArgs( std::ostream &os, int indent ) const {
 	std::list<Expression *>::const_iterator i;
-	for (i = args.begin(); i != args.end(); i++) {
-		os << std::string(indent, ' ' );
+	for (i = args.begin(); i != args.end(); i++)
 		(*i)->print(os, indent);
-	}
 }
 
@@ -402,5 +372,5 @@
 
 void NameExpr::print( std::ostream &os, int indent ) const {
-	os << "Name: " << get_name() << std::endl;
+	os << std::string( indent, ' ' ) << "Name: " << get_name() << std::endl;
 	Expression::print( os, indent );
 }