Index: .gitignore
===================================================================
--- .gitignore	(revision 7416d46ae4c80902ec659807c72c4b3d78cdba5c)
+++ .gitignore	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -9,8 +9,6 @@
 config.log
 stamp-h1
-Makefile
-driver/Makefile
-libcfa/Makefile
-src/Makefile
+/Makefile
+src/**/Makefile
 /version
 
Index: doc/papers/concurrency/.gitignore
===================================================================
--- doc/papers/concurrency/.gitignore	(revision 7416d46ae4c80902ec659807c72c4b3d78cdba5c)
+++ doc/papers/concurrency/.gitignore	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -1,29 +1,3 @@
-build/*.aux
-build/*.acn
-build/*.acr
-build/*.alg
-build/*.bbl
-build/*.blg
-build/*.brf
-build/*.dvi
-build/*.glg
-build/*.glo
-build/*.gls
-build/*.idx
-build/*.ind
-build/*.ist
-build/*.lof
-build/*.log
-build/*.lol
-build/*.lot
-build/*.out
-build/*.ps
-build/*.pstex
-build/*.pstex_t
-build/*.tex
-build/*.toc
+build/*
 *.pdf
-*.png
-figures/*.tex
-
-examples
+*.ps
Index: doc/papers/concurrency/Makefile
===================================================================
--- doc/papers/concurrency/Makefile	(revision 633a642259a81ef63c70e8867f8d610048550927)
+++ doc/papers/concurrency/Makefile	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -0,0 +1,87 @@
+## Define the configuration variables.
+
+Build = build
+Macros = ../../LaTeXmacros
+TeXLIB = .:style:annex:${Macros}:${Build}:/usr/local/bibliographies:
+LaTeX  = TEXINPUTS=${TeXLIB} && export TEXINPUTS && latex -halt-on-error -output-directory=${Build} -interaction=nonstopmode
+BibTeX = BIBINPUTS=${TeXLIB} && export BIBINPUTS && bibtex
+
+MAKEFLAGS = --no-print-directory --silent #
+
+## Define the text source files.
+
+SOURCES = ${addsuffix .tex, \
+Paper \
+style/style \
+style/cfa-format \
+}
+
+FIGURES = ${addsuffix .tex, \
+monitor \
+ext_monitor \
+int_monitor \
+dependency \
+}
+
+PICTURES = ${addsuffix .pstex, \
+system \
+monitor_structs \
+}
+
+PROGRAMS = ${addsuffix .tex, \
+}
+
+GRAPHS = ${addsuffix .tex, \
+}
+
+## Define the documents that need to be made.
+
+DOCUMENT = Paper.pdf
+
+# Directives #
+
+.PHONY : all clean										# not file names
+
+all : ${DOCUMENT}
+
+clean :
+	@rm -frv ${DOCUMENT} ${basename ${DOCUMENT}}.ps ${Build}
+
+# File Dependencies #
+
+${DOCUMENT} : ${basename ${DOCUMENT}}.ps
+	ps2pdf $<
+
+${basename ${DOCUMENT}}.ps : ${basename ${DOCUMENT}}.dvi
+	dvips ${Build}/$< -o $@
+
+${basename ${DOCUMENT}}.dvi : Makefile ${Build} ${GRAPHS} ${PROGRAMS} ${PICTURES} ${FIGURES} ${SOURCES} ${basename ${DOCUMENT}}.tex \
+			${Macros}/common.tex ${Macros}/indexstyle annex/local.bib /usr/local/bibliographies/pl.bib
+	if [ ! -r ${basename $@}.aux ] ; then ${LaTeX} ${basename $@}.tex ; fi # Must have *.aux file containing citations for bibtex
+	-${BibTeX} ${Build}/${basename $@}					# Some citations reference others so run again to resolve these citations
+	${LaTeX} ${basename $@}.tex
+	-${BibTeX} ${Build}/${basename $@}
+	${LaTeX} ${basename $@}.tex							# Finish citations
+
+## Define the default recipes.
+
+vpath %.tex ${subst .zzz,,${subst .zzz ,:,${SOURCES}}}	# add prefix for source
+vpath %.fig ${subst .zzz,,${subst .zzz ,:,${SOURCES}}}	# add prefix for source
+
+${Build}:
+	mkdir -p ${Build}
+
+%.tex : figures/%.fig
+	fig2dev -L eepic $< > ${Build}/$@
+
+%.ps : figures/%.fig
+	fig2dev -L ps $< > ${Build}/$@
+
+%.pstex : figures/%.fig
+	fig2dev -L pstex $< > ${Build}/$@
+	fig2dev -L pstex_t -p ${Build}/$@ $< > ${Build}/$@_t
+
+# Local Variables: #
+# tab-width : 4 #
+# compile-command: "make" #
+# End: #
Index: c/papers/concurrency/build/bump_ver.sh
===================================================================
--- doc/papers/concurrency/build/bump_ver.sh	(revision 7416d46ae4c80902ec659807c72c4b3d78cdba5c)
+++ 	(revision )
@@ -1,6 +1,0 @@
-#!/bin/bash
-if [ ! -f version ]; then
-    echo "0.0.0" > version
-fi
-
-sed -r 's/([0-9]+\.[0-9]+.)([0-9]+)/echo "\1\$((\2+1))" > version/ge' version > /dev/null
Index: c/papers/concurrency/version
===================================================================
--- doc/papers/concurrency/version	(revision 7416d46ae4c80902ec659807c72c4b3d78cdba5c)
+++ 	(revision )
@@ -1,1 +1,0 @@
-0.11.420
Index: doc/papers/general/Makefile
===================================================================
--- doc/papers/general/Makefile	(revision 633a642259a81ef63c70e8867f8d610048550927)
+++ doc/papers/general/Makefile	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -0,0 +1,83 @@
+## Define the configuration variables.
+
+Build = build
+Macros = ../../LaTeXmacros
+TeXLIB = .:${Macros}:${Build}:../../bibliography:
+LaTeX  = TEXINPUTS=${TeXLIB} && export TEXINPUTS && latex -halt-on-error -output-directory=${Build} -interaction=nonstopmode
+BibTeX = BIBINPUTS=${TeXLIB} && export BIBINPUTS && bibtex
+
+MAKEFLAGS = --no-print-directory --silent #
+
+## Define the text source files.
+
+SOURCES = ${addsuffix .tex, \
+Paper \
+}
+
+FIGURES = ${addsuffix .tex, \
+}
+
+PICTURES = ${addsuffix .pstex, \
+}
+
+PROGRAMS = ${addsuffix .tex, \
+}
+
+GRAPHS = ${addsuffix .tex, \
+timing \
+}
+
+## Define the documents that need to be made.
+
+DOCUMENT = Paper.pdf
+
+# Directives #
+
+.PHONY : all clean										# not file names
+
+all : ${DOCUMENT}
+
+clean :
+	@rm -frv ${DOCUMENT} ${basename ${DOCUMENT}}.ps ${Build}
+
+# File Dependencies #
+
+${DOCUMENT} : ${basename ${DOCUMENT}}.ps
+	ps2pdf $<
+
+${basename ${DOCUMENT}}.ps : ${basename ${DOCUMENT}}.dvi
+	dvips ${Build}/$< -o $@
+
+${basename ${DOCUMENT}}.dvi : Makefile ${Build} ${GRAPHS} ${PROGRAMS} ${PICTURES} ${FIGURES} ${SOURCES} ${basename ${DOCUMENT}}.tex \
+			${Macros}/common.tex ${Macros}/indexstyle ../../bibliography/cfa.bib
+	if [ ! -r ${basename $@}.aux ] ; then ${LaTeX} ${basename $@}.tex ; fi # Must have *.aux file containing citations for bibtex
+	-${BibTeX} ${Build}/${basename $@}					# Some citations reference others so run again to resolve these citations
+	${LaTeX} ${basename $@}.tex
+	-${BibTeX} ${Build}/${basename $@}
+	${LaTeX} ${basename $@}.tex							# Finish citations
+
+## Define the default recipes.
+
+vpath %.tex ${subst .zzz,,${subst .zzz ,:,${SOURCES}}}	# add prefix for source
+vpath %.fig ${subst .zzz,,${subst .zzz ,:,${SOURCES}}}	# add prefix for source
+
+${Build}:
+	mkdir -p ${Build}
+
+${GRAPHS} : evaluation/timing.gp evaluation/timing.dat
+	gnuplot evaluation/timing.gp
+
+%.tex : figures/%.fig
+	fig2dev -L eepic $< > ${Build}/$@
+
+%.ps : figures/%.fig
+	fig2dev -L ps $< > ${Build}/$@
+
+%.pstex : figures/%.fig
+	fig2dev -L pstex $< > ${Build}/$@
+	fig2dev -L pstex_t -p ${Build}/$@ $< > ${Build}/$@_t
+
+# Local Variables: #
+# tab-width : 4 #
+# compile-command: "make" #
+# End: #
Index: doc/papers/general/evaluation/Makefile
===================================================================
--- doc/papers/general/evaluation/Makefile	(revision 633a642259a81ef63c70e8867f8d610048550927)
+++ doc/papers/general/evaluation/Makefile	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -0,0 +1,97 @@
+CC = gcc
+CFA = cfa
+DEPFLAGS = -MMD -MP
+CFLAGS = -O2
+ifdef N
+CFLAGS += -DN=$(N)
+endif
+CXXFLAGS = $(CFLAGS) --std=c++14
+MAKEFILE_NAME = ${firstword ${MAKEFILE_LIST}}
+
+.PHONY : all clean run-c run-cpp run-cfa run
+
+all : c-bench cpp-bench cpp-vbench cfa-bench
+
+# rewrite object generation to auto-determine deps
+COMPILE.c = $(CC) $(DEPFLAGS) $(CFLAGS) $(CPPFLAGS)
+COMPILE.cpp = $(CXX) $(DEPFLAGS) $(CXXFLAGS) $(CPPFLAGS)
+COMPILE.cfa = $(CFA) $(DEPFLAGS) $(CFLAGS) $(CPPFLAGS)
+
+c-%.o : c-%.c
+	$(COMPILE.c) $(OUTPUT_OPTION) -c $<
+
+cpp-%.o : cpp-%.cpp
+	$(COMPILE.cpp) $(OUTPUT_OPTION) -c $<
+
+cfa-%.o : cfa-%.c
+	$(COMPILE.cfa) $(OUTPUT_OPTION) -c $<
+
+COBJS = c-stack.o c-pair.o c-print.o c-bench.o
+CPPOBJS = cpp-bench.o
+CPPVOBJS = cpp-vstack.o cpp-vbench.o
+CFAOBJS = cfa-stack.o cfa-pair.o cfa-print.o cfa-bench.o
+
+${COBJS} ${CPPOBJS} ${CPPVOBJS} ${CFAOBJS} : ${MAKEFILE_NAME}
+
+CFILES = bench.h $(patsubst c-bench.h,,$(COBJS:.o=.h)) $(COBJS:.o=.c)
+CPPFILES = bench.hpp cpp-stack.hpp cpp-pair.hpp cpp-print.hpp $(CPPOBJS:.o=.cpp)
+CPPVFILES = bench.hpp object.hpp cpp-vprint.hpp $(patsubst cpp-vbench.hpp,,$(CPPVOBJS:.o=.hpp)) $(CPPVOBJS:.o=.cpp)
+CFAFILES = bench.h $(patsubst cfa-bench.h,,$(CFAOBJS:.o=.h)) $(CFAOBJS:.o=.c)
+
+c-bench : $(COBJS) c-bench.o
+	$(COMPILE.c) $(LDFLAGS) $^ -o $@
+
+cpp-bench : $(CPPOBJS) cpp-bench.o
+	$(COMPILE.cpp) $(LDFLAGS) $^ -o $@
+
+cpp-vbench : $(CPPVOBJS) cpp-vbench.o
+	$(COMPILE.cpp) $(LDFLAGS) $^ -o $@
+
+cfa-bench : $(CFAOBJS) cfa-bench.o
+	$(COMPILE.cfa) $(LDFLAGS) $^ -o $@
+
+# include dependency files
+-include $(COBJS:.o=.d)
+-include $(CPPOBJS:.o=.d)
+-include $(CPPVOBJS:.o=.d)
+-include $(CFAOBJS:.o=.d)
+
+clean :
+	rm -f $(COBJS) $(COBJS:.o=.d) c-bench
+	rm -f $(CPPOBJS) $(CPPOBJS:.o=.d) cpp-bench
+	rm -f $(CPPVOBJS) $(CPPVOBJS:.o=.d) cpp-vbench
+	rm -f $(CFAOBJS) $(CFAOBJS:.o=.d) cfa-bench
+
+run-c : c-bench
+	@echo
+	@echo '## C ##'
+	@/usr/bin/time -f 'max_memory:\t%M kilobytes' ./$<
+	@printf 'source_size:\t%8d lines\n' `cat $(CFILES) | wc -l`
+	@printf 'redundant_type_annotations:%8d lines\n' `cat $(CFILES) | fgrep '/***/' -c`
+	@printf 'binary_size:\t%8d bytes\n' `stat -c %s $<`
+
+run-cpp : cpp-bench
+	@echo
+	@echo '## C++ ##'
+	@/usr/bin/time -f 'max_memory:\t %M kilobytes' ./$<
+	@printf 'source_size:\t%8d lines\n' `cat $(CPPFILES) | wc -l`
+	@printf 'redundant_type_annotations:%8d lines\n' `cat $(CPPFILES) | fgrep '/***/' -c`
+	@printf 'binary_size:\t%8d bytes\n' `stat -c %s $<`
+
+run-cppv : cpp-vbench
+	@echo
+	@echo '## C++obj ##'
+	@/usr/bin/time -f 'max_memory:\t%M kilobytes' ./$<
+	@printf 'source_size:\t%8d lines\n' `cat $(CPPVFILES) | wc -l`
+	@printf 'redundant_type_annotations:%8d lines\n' `cat $(CPPVFILES) | fgrep '/***/' -c`
+	@printf 'binary_size:\t%8d bytes\n' `stat -c %s $<`
+
+run-cfa : cfa-bench
+	@echo
+	@echo '## Cforall ##'
+	@/usr/bin/time -f 'max_memory:\t %M kilobytes' ./$<
+	@printf 'source_size:\t%8d lines\n' `cat $(CFAFILES) | wc -l`
+	@printf 'redundant_type_annotations:%8d lines\n' `cat $(CFAFILES) | fgrep '/***/' -c`
+	@printf 'binary_size:\t%8d bytes\n' `stat -c %s $<`
+
+run : run-c run-cfa run-cpp run-cppv
Index: src/driver/cfa.cc
===================================================================
--- src/driver/cfa.cc	(revision 7416d46ae4c80902ec659807c72c4b3d78cdba5c)
+++ src/driver/cfa.cc	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -10,6 +10,6 @@
 // Created On       : Tue Aug 20 13:44:49 2002
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Tue Oct 31 11:40:44 2017
-// Update Count     : 160
+// Last Modified On : Tue Jan 30 15:46:15 2018
+// Update Count     : 161
 //
 
@@ -358,4 +358,6 @@
 		args[nargs] = "-D__int8_t_defined";				// prevent gcc type-size attributes
 		nargs += 1;
+		args[nargs] = "-D__NO_STRING_INLINES";			// prevent gcc strcmp unrolling
+		nargs += 1;
 		args[nargs] = ( *new string( string("-B") + Bprefix + "/" ) ).c_str();
 		nargs += 1;
Index: src/tests/concurrent/examples/quickSort.c
===================================================================
--- src/tests/concurrent/examples/quickSort.c	(revision 7416d46ae4c80902ec659807c72c4b3d78cdba5c)
+++ src/tests/concurrent/examples/quickSort.c	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -9,6 +9,6 @@
 // Created On       : Wed Dec  6 12:15:52 2017
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Jan 29 08:41:37 2018
-// Update Count     : 155
+// Last Modified On : Tue Jan 30 15:58:58 2018
+// Update Count     : 162
 //
 
@@ -100,6 +100,5 @@
 	if ( argc != 1 ) {									// do not use defaults
 		if ( argc < 2 || argc > 4 ) usage( argv );		// wrong number of options
-//		if ( strcmp( argv[1], "-t" ) == 0 ) {			// timing ?
-		if ( argv[1][0] == '-' && argv[1][1] == 't' ) {	// timing ?
+		if ( strcmp( argv[1], "-t" ) == 0 ) {			// timing ?
 			&unsortedfile = (ifstream *)0;				// no input
 			choose ( argc ) {
Index: src/tests/functions.c
===================================================================
--- src/tests/functions.c	(revision 7416d46ae4c80902ec659807c72c4b3d78cdba5c)
+++ src/tests/functions.c	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -10,6 +10,6 @@
 // Created On       : Wed Aug 17 08:39:58 2016
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Nov 27 18:08:54 2017
-// Update Count     : 11
+// Last Modified On : Wed Jan 17 22:44:12 2018
+// Update Count     : 12
 // 
 
@@ -25,5 +25,5 @@
 	void g(void)
 	) {
-	(*g)();
+	(* g)();
 	g();
 	g = h;
@@ -32,14 +32,14 @@
 int f1() {}
 int (f2()) {}
-int (*f3())() {}
-int *((f4())) {}
-int ((*f5()))() {}
-int *f6() {}
-int *(f7)() {}
-int **f8() {}
-int * const *(f9)() {}
-int (*f10())[] {}
-int (*f11())[][3] {}
-int ((*f12())[])[3] {}
+int (* f3())() {}
+int * ((f4())) {}
+int ((* f5()))() {}
+int * f6() {}
+int * (f7)() {}
+int ** f8() {}
+int * const * (f9)() {}
+int (* f10())[] {}
+int (* f11())[][3] {}
+int ((* f12())[])[3] {}
 
 // "implicit int" otype specifier (not ANSI)
@@ -50,9 +50,9 @@
 extern const fII4( int i ) {}
 
-*fII5() {}
-const *fII6() {}
-const long *fII7() {}
-static const long *fII8() {}
-const static long *fII9() {}
+* fII5() {}
+const * fII6() {}
+const long * fII7() {}
+static const long * fII8() {}
+const static long * fII9() {}
 
 // K&R function definitions
@@ -117,10 +117,10 @@
 	[int](int)
 	) {
-	int (*(*pc)[][10])[][3];
+	int (* (* pc)[][10])[][3];
 	* [][10] * [][3] int p;
 	* [] * [int](int) p;
 }
 
-static const int *f1() {}
+static const int * f1() {}
 static [ const int ] f2() {}
 static inline [ const * int ] f3() {}
@@ -133,7 +133,7 @@
 	int (),
 
-	int *(),
-	int **(),
-	int * const *(),
+	int * (),
+	int ** (),
+	int * const * (),
 	int * const * const (),
 
@@ -141,10 +141,10 @@
 	int ([10]),
 
-	int *([]),
-	int *([10]),
-	int **([]),
-	int **([10]),
-	int * const *([]),
-	int * const *([10]),
+	int * ([]),
+	int * ([10]),
+	int ** ([]),
+	int ** ([10]),
+	int * const * ([]),
+	int * const * ([10]),
 	int * const * const ([]),
 	int * const * const ([10])
@@ -154,7 +154,7 @@
 	int (),
 
-	int *(),
-	int **(),
-	int * const *(),
+	int * (),
+	int ** (),
+	int * const * (),
 	int * const * const (),
 
@@ -162,10 +162,10 @@
 	int ([10]),
 
-	int *([]),
-	int *([10]),
-	int **([]),
-	int **([10]),
-	int * const *([]),
-	int * const *([10]),
+	int * ([]),
+	int * ([10]),
+	int ** ([]),
+	int ** ([10]),
+	int * const * ([]),
+	int * const * ([10]),
 	int * const * const ([]),
 	int * const * const ([10])
@@ -175,5 +175,5 @@
 typedef int T;
 
-int f( T (*f), T t ) {
+int f( T (* f), T t ) {
 	T (T);
 }
@@ -184,5 +184,5 @@
 //int (f[])() {}
 //int f[]() {}
-//int ((*f15())())[] {}
+//int ((* f15())())[] {}
 
 // Local Variables: //
Index: src/tests/identFuncDeclarator.c
===================================================================
--- src/tests/identFuncDeclarator.c	(revision 7416d46ae4c80902ec659807c72c4b3d78cdba5c)
+++ src/tests/identFuncDeclarator.c	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -10,6 +10,6 @@
 // Created On       : Wed Aug 17 08:36:34 2016
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Wed Aug 17 08:37:06 2016
-// Update Count     : 1
+// Last Modified On : Wed Jan 17 22:39:13 2018
+// Update Count     : 2
 // 
 
@@ -18,17 +18,17 @@
 	int (f2);
 
-	int *f3;
-	int **f4;
-	int * const *f5;
+	int * f3;
+	int ** f4;
+	int * const * f5;
 	int * const * const f6;
 
-	int *(f7);
-	int **(f8);
-	int * const *(f9);
+	int * (f7);
+	int ** (f8);
+	int * const * (f9);
 	int * const * const (f10);
 
-	int (*f11);
-	int (**f12);
-	int (* const *f13);
+	int (* f11);
+	int (** f12);
+	int (* const * f13);
 	int (* const * const f14);
 
@@ -38,28 +38,28 @@
 	int (f18[10]);
 
-	int *f19[2];
-	int *f20[10];
-	int **f21[2];
-	int **f22[10];
-	int * const *f23[2];
-	int * const *f24[10];
+	int * f19[2];
+	int * f20[10];
+	int ** f21[2];
+	int ** f22[10];
+	int * const * f23[2];
+	int * const * f24[10];
 	int * const * const f25[2];
 	int * const * const f26[10];
 
-	int *(f27[2]);
-	int *(f28[10]);
-	int **(f29[2]);
-	int **(f30[10]);
-	int * const *(f31[2]);
-	int * const *(f32[10]);
+	int * (f27[2]);
+	int * (f28[10]);
+	int ** (f29[2]);
+	int ** (f30[10]);
+	int * const * (f31[2]);
+	int * const * (f32[10]);
 	int * const * const (f33[2]);
 	int * const * const (f34[10]);
 
-	int (*f35[2]);
-	int (*f36[10]);
-	int (**f37[2]);
-	int (**f38[10]);
-	int (* const *f39[2]);
-	int (* const *f40[10]);
+	int (* f35[2]);
+	int (* f36[10]);
+	int (** f37[2]);
+	int (** f38[10]);
+	int (* const * f39[2]);
+	int (* const * f40[10]);
 	int (* const * const f41[2]);
 	int (* const * const f42[10]);
@@ -72,19 +72,19 @@
 	int ((f48[3]))[3];
 
-	int *f49[2][3];
-	int *f50[3][3];
-	int **f51[2][3];
-	int **f52[3][3];
-	int * const *f53[2][3];
-	int * const *f54[3][3];
+	int * f49[2][3];
+	int * f50[3][3];
+	int ** f51[2][3];
+	int ** f52[3][3];
+	int * const * f53[2][3];
+	int * const * f54[3][3];
 	int * const * const f55[2][3];
 	int * const * const f56[3][3];
 
-	int (*f57[2][3]);
-	int (*f58[3][3]);
-	int (**f59[2][3]);
-	int (**f60[3][3]);
-	int (* const *f61[2][3]);
-	int (* const *f62[3][3]);
+	int (* f57[2][3]);
+	int (* f58[3][3]);
+	int (** f59[2][3]);
+	int (** f60[3][3]);
+	int (* const * f61[2][3]);
+	int (* const * f62[3][3]);
 	int (* const * const f63[2][3]);
 	int (* const * const f64[3][3]);
@@ -93,21 +93,21 @@
 	int (f66)(int);
 
-	int *f67(int);
-	int **f68(int);
-	int * const *f69(int);
+	int * f67(int);
+	int ** f68(int);
+	int * const * f69(int);
 	int * const * const f70(int);
 
-	int *(f71)(int);
-	int **(f72)(int);
-	int * const *(f73)(int);
+	int * (f71)(int);
+	int ** (f72)(int);
+	int * const * (f73)(int);
 	int * const * const (f74)(int);
 
-	int (*f75)(int);
-	int (**f76)(int);
-	int (* const *f77)(int);
+	int (* f75)(int);
+	int (** f76)(int);
+	int (* const * f77)(int);
 	int (* const * const f78)(int);
 
-	int (*(*f79)(int))();
-	int (*(* const f80)(int))();
+	int (* (* f79)(int))();
+	int (* (* const f80)(int))();
 	int (* const(* const f81)(int))();
 }
Index: src/tests/identParamDeclarator.c
===================================================================
--- src/tests/identParamDeclarator.c	(revision 7416d46ae4c80902ec659807c72c4b3d78cdba5c)
+++ src/tests/identParamDeclarator.c	(revision 633a642259a81ef63c70e8867f8d610048550927)
@@ -10,9 +10,9 @@
 // Created On       : Wed Aug 17 08:37:56 2016
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Wed Aug 17 08:38:42 2016
-// Update Count     : 1
+// Last Modified On : Wed Jan 17 22:36:11 2018
+// Update Count     : 2
 // 
 
-int fred(
+int fred (
 	int f1,
 	int (f2),
@@ -157,7 +157,5 @@
     );
 
-//Dummy main
-int main(int argc, char const *argv[])
-{
+int main( int argc, char const *argv[] ) {				// dummy main
 	return 0;
 }