Index: src/Common/ScopedMap.h
===================================================================
--- src/Common/ScopedMap.h	(revision 22f94a4397386dcee79764eace3e5c71e0455838)
+++ src/Common/ScopedMap.h	(revision 683cc13c9ba06bb8e08de90adf11a9d0d3976f9c)
@@ -10,6 +10,6 @@
 // Created On       : Wed Dec 2 11:37:00 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon May 21 15:22:40 2018
-// Update Count     : 3
+// Last Modified On : Tue Feb 15 08:41:28 2022
+// Update Count     : 5
 //
 
@@ -36,11 +36,11 @@
 
 		template<typename N>
-		Scope(N&& n) : map(), note(std::forward<N>(n)) {}
+		Scope(N && n) : map(), note(std::forward<N>(n)) {}
 		
 		Scope() = default;
-		Scope(const Scope&) = default;
-		Scope(Scope&&) = default;
-		Scope& operator= (const Scope&) = default;
-		Scope& operator= (Scope&&) = default;
+		Scope(const Scope &) = default;
+		Scope(Scope &&) = default;
+		Scope & operator= (const Scope &) = default;
+		Scope & operator= (Scope &&) = default;
 	};
 	typedef std::vector< Scope > ScopeList;
@@ -58,6 +58,5 @@
 	typedef typename MapType::const_pointer const_pointer;
 
-	class iterator : public std::iterator< std::bidirectional_iterator_tag,
-	                                       value_type > {
+	class iterator : public std::iterator< std::bidirectional_iterator_tag, value_type > {
 	friend class ScopedMap;
 	friend class const_iterator;
@@ -72,5 +71,5 @@
 
 		/// Increments on invalid
-		iterator& next_valid() {
+		iterator & next_valid() {
 			if ( ! is_valid() ) { ++(*this); }
 			return *this;
@@ -78,14 +77,14 @@
 
 		/// Decrements on invalid
-		iterator& prev_valid() {
+		iterator & prev_valid() {
 			if ( ! is_valid() ) { --(*this); }
 			return *this;
 		}
 
-		iterator(scope_list &_scopes, const wrapped_iterator &_it, size_type inLevel)
+		iterator(scope_list & _scopes, const wrapped_iterator & _it, size_type inLevel)
 			: scopes(&_scopes), it(_it), level(inLevel) {}
 	public:
-		iterator(const iterator &that) : scopes(that.scopes), it(that.it), level(that.level) {}
-		iterator& operator= (const iterator &that) {
+		iterator(const iterator & that) : scopes(that.scopes), it(that.it), level(that.level) {}
+		iterator & operator= (const iterator & that) {
 			scopes = that.scopes; level = that.level; it = that.it;
 			return *this;
@@ -95,5 +94,5 @@
 		pointer operator-> () const { return it.operator->(); }
 
-		iterator& operator++ () {
+		iterator & operator++ () {
 			if ( it == (*scopes)[level].map.end() ) {
 				if ( level == 0 ) return *this;
@@ -107,5 +106,5 @@
 		iterator operator++ (int) { iterator tmp = *this; ++(*this); return tmp; }
 
-		iterator& operator-- () {
+		iterator & operator-- () {
 			// may fail if this is the begin iterator; allowed by STL spec
 			if ( it == (*scopes)[level].map.begin() ) {
@@ -118,13 +117,13 @@
 		iterator operator-- (int) { iterator tmp = *this; --(*this); return tmp; }
 
-		bool operator== (const iterator &that) const {
+		bool operator== (const iterator & that) const {
 			return scopes == that.scopes && level == that.level && it == that.it;
 		}
-		bool operator!= (const iterator &that) const { return !( *this == that ); }
+		bool operator!= (const iterator & that) const { return !( *this == that ); }
 
 		size_type get_level() const { return level; }
 
-		Note& get_note() { return (*scopes)[level].note; }
-		const Note& get_note() const { return (*scopes)[level].note; }
+		Note & get_note() { return (*scopes)[level].note; }
+		const Note & get_note() const { return (*scopes)[level].note; }
 
 	private:
@@ -148,5 +147,5 @@
 
 		/// Increments on invalid
-		const_iterator& next_valid() {
+		const_iterator & next_valid() {
 			if ( ! is_valid() ) { ++(*this); }
 			return *this;
@@ -154,19 +153,19 @@
 
 		/// Decrements on invalid
-		const_iterator& prev_valid() {
+		const_iterator & prev_valid() {
 			if ( ! is_valid() ) { --(*this); }
 			return *this;
 		}
 
-		const_iterator(scope_list const &_scopes, const wrapped_const_iterator &_it, size_type inLevel)
+		const_iterator(scope_list const & _scopes, const wrapped_const_iterator & _it, size_type inLevel)
 			: scopes(&_scopes), it(_it), level(inLevel) {}
 	public:
-		const_iterator(const iterator &that) : scopes(that.scopes), it(that.it), level(that.level) {}
-		const_iterator(const const_iterator &that) : scopes(that.scopes), it(that.it), level(that.level) {}
-		const_iterator& operator= (const iterator &that) {
+		const_iterator(const iterator & that) : scopes(that.scopes), it(that.it), level(that.level) {}
+		const_iterator(const const_iterator & that) : scopes(that.scopes), it(that.it), level(that.level) {}
+		const_iterator & operator= (const iterator & that) {
 			scopes = that.scopes; level = that.level; it = that.it;
 			return *this;
 		}
-		const_iterator& operator= (const const_iterator &that) {
+		const_iterator & operator= (const const_iterator & that) {
 			scopes = that.scopes; level = that.level; it = that.it;
 			return *this;
@@ -176,5 +175,5 @@
 		const_pointer operator-> () { return it.operator->(); }
 
-		const_iterator& operator++ () {
+		const_iterator & operator++ () {
 			if ( it == (*scopes)[level].map.end() ) {
 				if ( level == 0 ) return *this;
@@ -188,5 +187,5 @@
 		const_iterator operator++ (int) { const_iterator tmp = *this; ++(*this); return tmp; }
 
-		const_iterator& operator-- () {
+		const_iterator & operator-- () {
 			// may fail if this is the begin iterator; allowed by STL spec
 			if ( it == (*scopes)[level].map.begin() ) {
@@ -199,12 +198,12 @@
 		const_iterator operator-- (int) { const_iterator tmp = *this; --(*this); return tmp; }
 
-		bool operator== (const const_iterator &that) const {
+		bool operator== (const const_iterator & that) const {
 			return scopes == that.scopes && level == that.level && it == that.it;
 		}
-		bool operator!= (const const_iterator &that) const { return !( *this == that ); }
+		bool operator!= (const const_iterator & that) const { return !( *this == that ); }
 
 		size_type get_level() const { return level; }
 
-		const Note& get_note() const { return (*scopes)[level].note; }
+		const Note & get_note() const { return (*scopes)[level].note; }
 
 	private:
@@ -221,5 +220,5 @@
 	// Starts a new scope with the given note
 	template<typename N>
-	void beginScope( N&& n ) {
+	void beginScope( N && n ) {
 		scopes.emplace_back( std::forward<N>(n) );
 	}
@@ -236,5 +235,5 @@
 	/// Constructs with a given note on the outermost scope
 	template<typename N>
-	ScopedMap( N&& n ) : scopes() { beginScope(std::forward<N>(n)); }
+	ScopedMap( N && n ) : scopes() { beginScope(std::forward<N>(n)); }
 
 	iterator begin() { return iterator(scopes, scopes.back().map.begin(), currentScope()).next_valid(); }
@@ -249,11 +248,11 @@
 
 	/// Gets the note at the given scope
-	Note& getNote() { return scopes.back().note; }
-	const Note& getNote() const { return scopes.back().note; }
-	Note& getNote( size_type i ) { return scopes[i].note; }
-	const Note& getNote( size_type i ) const { return scopes[i].note; }
+	Note & getNote() { return scopes.back().note; }
+	const Note & getNote() const { return scopes.back().note; }
+	Note & getNote( size_type i ) { return scopes[i].note; }
+	const Note & getNote( size_type i ) const { return scopes[i].note; }
 
 	/// Finds the given key in the outermost scope it occurs; returns end() for none such
-	iterator find( const Key &key ) {
+	iterator find( const Key & key ) {
 		for ( size_type i = scopes.size() - 1; ; --i ) {
 			typename MapType::iterator val = scopes[i].map.find( key );
@@ -263,20 +262,20 @@
 		return end();
 	}
-	const_iterator find( const Key &key ) const {
+	const_iterator find( const Key & key ) const {
 			return const_iterator( const_cast< ScopedMap< Key, Value, Note >* >(this)->find( key ) );
 	}
 
 	/// Finds the given key in the provided scope; returns end() for none such
-	iterator findAt( size_type scope, const Key& key ) {
+	iterator findAt( size_type scope, const Key & key ) {
 		typename MapType::iterator val = scopes[scope].map.find( key );
 		if ( val != scopes[scope].map.end() ) return iterator( scopes, val, scope );
 		return end();
 	}
-	const_iterator findAt( size_type scope, const Key& key ) const {
+	const_iterator findAt( size_type scope, const Key & key ) const {
 		return const_iterator( const_cast< ScopedMap< Key, Value, Note >* >(this)->findAt( scope, key ) );
 	}
 
 	/// Finds the given key in the outermost scope inside the given scope where it occurs
-	iterator findNext( const_iterator &it, const Key &key ) {
+	iterator findNext( const_iterator & it, const Key & key ) {
 		if ( it.level == 0 ) return end();
 		for ( size_type i = it.level - 1; ; --i ) {
@@ -287,5 +286,5 @@
 		return end();
 	}
-	const_iterator findNext( const_iterator &it, const Key &key ) const {
+	const_iterator findNext( const_iterator & it, const Key & key ) const {
 			return const_iterator( const_cast< ScopedMap< Key, Value, Note >* >(this)->findNext( it, key ) );
 	}
@@ -293,5 +292,5 @@
 	/// Inserts the given key-value pair into the outermost scope
 	template< typename value_type_t >
-	std::pair< iterator, bool > insert( value_type_t&& value ) {
+	std::pair< iterator, bool > insert( value_type_t && value ) {
 		std::pair< typename MapType::iterator, bool > res = scopes.back().map.insert( std::forward<value_type_t>( value ) );
 		return std::make_pair( iterator(scopes, std::move( res.first ), scopes.size()-1), std::move( res.second ) );
@@ -299,6 +298,6 @@
 
 	template< typename value_type_t >
-	std::pair< iterator, bool > insert( iterator at, value_type_t&& value ) {
-		MapType& scope = (*at.scopes)[ at.level ].map;
+	std::pair< iterator, bool > insert( iterator at, value_type_t && value ) {
+		MapType & scope = (*at.scopes)[ at.level ].map;
 		std::pair< typename MapType::iterator, bool > res = scope.insert( std::forward<value_type_t>( value ) );
 		return std::make_pair( iterator(scopes, std::move( res.first ), at.level), std::move( res.second ) );
@@ -306,8 +305,8 @@
 
 	template< typename value_t >
-	std::pair< iterator, bool > insert( const Key &key, value_t&& value ) { return insert( std::make_pair( key, std::forward<value_t>( value ) ) ); }
+	std::pair< iterator, bool > insert( const Key & key, value_t && value ) { return insert( std::make_pair( key, std::forward<value_t>( value ) ) ); }
 
 	template< typename value_type_t >
-	std::pair< iterator, bool > insertAt( size_type scope, value_type_t&& value ) {
+	std::pair< iterator, bool > insertAt( size_type scope, value_type_t && value ) {
 		std::pair< typename MapType::iterator, bool > res = scopes.at(scope).map.insert( std::forward<value_type_t>( value ) );
 		return std::make_pair( iterator(scopes, std::move( res.first ), scope), std::move( res.second ) );
@@ -315,9 +314,9 @@
 
 	template< typename value_t >
-	std::pair< iterator, bool > insertAt( size_type scope, const Key& key, value_t&& value ) {
+	std::pair< iterator, bool > insertAt( size_type scope, const Key & key, value_t && value ) {
 		return insertAt( scope, std::make_pair( key, std::forward<value_t>( value ) ) );
 	}
 
-	Value& operator[] ( const Key &key ) {
+	Value & operator[] ( const Key & key ) {
 		iterator slot = find( key );
 		if ( slot != end() ) return slot->second;
@@ -326,11 +325,11 @@
 
 	iterator erase( iterator pos ) {
-		MapType& scope = (*pos.scopes)[ pos.level ].map;
-		const typename iterator::wrapped_iterator& new_it = scope.erase( pos.it );
+		MapType & scope = (*pos.scopes)[ pos.level ].map;
+		const typename iterator::wrapped_iterator & new_it = scope.erase( pos.it );
 		iterator it( *pos.scopes, new_it, pos.level );
 		return it.next_valid();
 	}
 
-	size_type count( const Key &key ) const {
+	size_type count( const Key & key ) const {
 		size_type c = 0;
 		auto it = find( key );
@@ -344,5 +343,4 @@
 		return c;
 	}
-
 };
 